decidim-admin/config/routes.rb
# frozen_string_literal: true

Decidim::Admin::Engine.routes.draw do
  constraints(->(request) { Decidim::Admin::OrganizationDashboardConstraint.new(request).matches? }) do
    resource :organization, only: [:edit, :update], controller: "organization" do
      resource :appearance, only: [:edit, :update], controller: "organization_appearance"
      resource :homepage, only: [:edit, :update], controller: "organization_homepage" do
        resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "organization_homepage_content_blocks"
      end
      resource :external_domain_allowlist, only: [:edit, :update], controller: "organization_external_domain_allowlist"

      member do
        get :users
      end
    end

    resources :static_pages do
      put :update_content_blocks, on: :member
      resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "static_page_content_blocks"
    end
    resources :static_page_topics
    resources :scope_types, except: [:show]
    resources :scopes, except: [:show] do
      resources :scopes, except: [:show]
    end
    resources :metrics, only: [:index]
    resources :logs, only: [:index]
    resources :area_types, except: [:show]
    resources :areas, except: [:show]

    resources :authorization_workflows, only: :index

    resources :users, except: [:edit, :update], controller: "users" do
      member do
        post :resend_invitation, to: "users#resend_invitation"
      end
    end

    resources :officializations, only: [:new, :create, :index, :destroy], param: :user_id do
      member do
        get :show_email
      end
    end

    resources :moderated_users, only: [:index] do
      member do
        put :ignore
      end
      collection do
        scope "/:user_id" do
          resource :user_block, only: [:new, :create, :destroy], controller: :block_user
        end
        post :bulk_new, controller: :block_user
        post :bulk_create, controller: :block_user
        delete :bulk_destroy, controller: :block_user
        patch :bulk_unreport, controller: :moderated_users
      end
    end

    resources :impersonatable_users, only: [:index] do
      resources :promotions, controller: "managed_users/promotions", only: [:new, :create]
      resources :impersonation_logs, controller: "managed_users/impersonation_logs", only: [:index]
      resources :impersonations, controller: "impersonations", only: [:new, :create] do
        collection do
          post :close_session
        end
      end
    end

    resources :newsletter_templates, only: [:index, :show] do
      resources :newsletters, only: [:new, :create]

      member do
        get :preview
      end
    end

    resources :newsletters, except: [:new, :create] do
      member do
        post :recipients_count
        post :send_to_user
        get :preview
        get :select_recipients_to_deliver
        post :deliver
        get :confirm_recipients
      end
    end

    resource :help_sections, only: [:show, :update]

    namespace :admin_terms do
      get :show
      put :accept
    end

    resources :moderations, controller: "global_moderations" do
      member do
        put :unreport
        put :hide
        put :unhide
      end
      patch :bulk_action, on: :collection
      resources :reports, controller: "global_moderations/reports", only: [:index, :show]
    end

    resources :conflicts, only: [:index, :edit, :update], controller: "conflicts"

    resources :taxonomies, except: [:show] do
      patch :reorder, on: :collection
      resources :items, only: [:new, :create, :edit, :update], controller: "taxonomy_items"
      resources :filters, except: [:show], controller: "taxonomy_filters"
    end
    resources :taxonomy_filters_selector, param: :taxonomy_filter_id, except: [:edit, :update]

    root to: "dashboard#show"
  end
end

decidim-admin/app/controllers/concerns/decidim/moderated_users/admin/filterable.rb
# frozen_string_literal: true

require "active_support/concern"

module Decidim
  module ModeratedUsers
    module Admin
      module Filterable
        extend ActiveSupport::Concern

        included do
          include Decidim::Admin::Filterable

          private

          def base_query
            collection
          end

          def filters
            [
              :reports_reason_eq
            ]
          end

          def filters_with_values
            {
              reports_reason_eq: report_reasons
            }
          end

          def dynamically_translated_filters
            []
          end

          def search_field_predicate
            :user_name_or_user_nickname_or_user_email_cont
          end

          def report_reasons
            Decidim::UserReport::REASONS
          end

          def extra_allowed_params
            [:per_page, :blocked]
          end
        end
      end
    end
  end
end

decidim-admin/app/controllers/decidim/admin/moderated_users_controller.rb
# frozen_string_literal: true

module Decidim
  module Admin
    class ModeratedUsersController < Decidim::Admin::ApplicationController
      include Decidim::ModeratedUsers::Admin::Filterable

      helper_method :moderated_users

      layout "decidim/admin/global_moderations"

      before_action :set_moderation_breadcrumb_item

      def index
        enforce_permission_to :read, :moderate_users

        @moderated_users = filtered_collection
      end

      def ignore
        enforce_permission_to :unreport, :moderate_users

        Admin::UnreportUser.call(reportable, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("reportable.unreport.success", scope: "decidim.moderations.admin")
            redirect_to moderated_users_path
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("reportable.unreport.invalid", scope: "decidim.moderations.admin")
            redirect_to moderated_users_path
          end
        end
      end

      def bulk_unreport
        Admin::BulkUnreportUsers.call(current_user, reportables) do
          on(:ok) do
            flash[:notice] = I18n.t("reportable.bulk_action.ignore.success", scope: "decidim.moderations.admin")
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("reportable.bulk_action.ignore.invalid", scope: "decidim.moderations.admin")
          end
        end
        redirect_to moderated_users_path
      end

      private

      def moderated_users
        @moderated_users ||= filtered_collection
      end

      def reportable
        @reportable ||= base_query_finder.find(params[:id]).user
      end

      def reportables
        @reportables ||= Decidim::UserBaseEntity.where(
          id: params[:user_ids],
          organization: current_organization
        )
      end

      def base_query_finder
        Decidim::Admin::ModerationStats.new(current_user).user_reports
      end

      def collection
        @collection ||= if params[:blocked]
                          base_query_finder.blocked
                        else
                          base_query_finder.unblocked
                        end
      end

      def set_moderation_breadcrumb_item
        controller_breadcrumb_items << {
          label: I18n.t("menu.reported_users", scope: "decidim.admin"),
          url: decidim_admin.moderated_users_path,
          active: true
        }
      end
    end
  end
end

decidim-admin/app/helpers/decidim/admin/bulk_actions_helper.rb
# frozen_string_literal: true

module Decidim
  module Admin
    module BulkActionsHelper
      # Public: Generates a select field with the components.
      #
      # siblings - A collection of components.
      #
      # Returns a String.
      def bulk_components_select(siblings)
        components = siblings.map do |component|
          [translated_attribute(component.name, component.organization), component.id]
        end

        prompt = t("decidim.proposals.admin.proposals.index.select_component")
        select(:target_component_id, nil, options_for_select(components, selected: []), prompt:)
      end
    end
  end
end

decidim-admin/app/views/decidim/admin/moderated_users/bulk_actions/_block.html.erb
<div id="js-block-moderated_users-actions" class="hide js-bulk-action-form">
  <%= form_tag(bulk_new_moderated_users_path, method: :post, id: "js-form-block-moderated_users", class: "form form-defaults flex items-center gap-x-2") do %>

    <div class="hide">
      <% moderated_users.each do |moderation| %>
        <%= check_box_tag "user_ids[]", moderation.user.id, false, class: "js-check-all-moderated_users js-moderated_user-id-#{moderation.user.id}" %>
      <% end %>
    </div>

    <%= submit_tag(
          t("decidim.admin.moderated_users.index.actions.bulk_actions.block.update_moderated_user_button"),
          id: "js-submit-block-moderated_users",
          class: "button button__sm button__secondary small button--simple float-left"
        ) %>

    <button id="js-cancel-block-moderated_users" class="button button__sm button__secondary js-cancel-bulk-action" type="button">
      <%= t("decidim.admin.moderated_users.index.cancel") %>
    </button>
  <% end %>
</div>

decidim-admin/app/views/decidim/admin/moderated_users/bulk_actions/_dropdown.html.erb
<div id="js-bulk-actions-wrapper">
  <button
    id="js-bulk-actions-button"
    class="button button__sm button__secondary"
    type="button"
    data-toggle="js-bulk-actions-dropdown">
    <%= t("decidim.admin.moderated_users.index.actions.bulk_actions.actions_dropdown") %>
    <%= icon "arrow-down-s-line", class: "dropdown-filter-icon" %>
  </button>

  <div
    id="js-bulk-actions-dropdown"
    class="dropdown-pane"
    data-position="bottom"
    data-alignment="right"
    data-dropdown="dropdown"
    data-auto-focus="false"
    data-events="resize">
    <ul>
      <% if params[:blocked] %>
        <li>
          <button type="button" data-action="unblock-moderated_users">
            <%= t("decidim.admin.moderated_users.index.actions.bulk_actions.unblock.title") %>
          </button>
        </li>
      <% else %>
        <li>
          <button type="button" data-action="block-moderated_users">
            <%= t("decidim.admin.moderated_users.index.actions.bulk_actions.block.title") %>
          </button>
        </li>
        <li>
          <button type="button" data-action="unreport-moderated_users">
            <%= t("decidim.admin.moderated_users.index.actions.bulk_actions.unreport.title") %>
          </button>
        </li>
      <% end %>
    </ul>
  </div>
</div>

decidim-admin/app/views/decidim/admin/moderated_users/bulk_actions/_unblock.html.erb
<div id="js-unblock-moderated_users-actions" class="hide js-bulk-action-form">
  <%= form_tag(bulk_destroy_moderated_users_path, method: :delete, id: "js-form-unblock-moderated_users", class: "form form-defaults flex items-center gap-x-2") do %>

    <div class="hide">
      <% moderated_users.each do |moderation| %>
        <%= check_box_tag "user_ids[]", moderation.user.id, false, class: "js-check-all-moderated_users js-moderated_user-id-#{moderation.user.id}" %>
      <% end %>
    </div>

    <%= submit_tag(
          t("decidim.admin.moderated_users.index.actions.bulk_actions.unblock.update_moderated_user_button"),
          id: "js-submit-unblock-moderated_users",
          class: "button button__sm button__secondary small button--simple float-left"
        ) %>

    <button id="js-cancel-unblock-moderated_users" class="button button__sm button__secondary js-cancel-bulk-action" type="button">
      <%= t("decidim.admin.moderated_users.index.cancel") %>
    </button>
  <% end %>
</div>

decidim-admin/app/views/decidim/admin/moderated_users/bulk_actions/_unreport.html.erb
<div id="js-unreport-moderated_users-actions" class="hide js-bulk-action-form">
  <%= form_tag(bulk_unreport_moderated_users_path, method: :patch, id: "js-form-unreport-moderated_users", class: "form form-defaults flex items-center gap-x-2") do %>

    <div class="hide">
      <% moderated_users.each do |moderation| %>
        <%= check_box_tag "user_ids[]", moderation.user.id, false, class: "js-check-all-moderated_users js-moderated_user-id-#{moderation.user.id}" %>
      <% end %>
    </div>

    <%= submit_tag(
          t("decidim.admin.moderated_users.index.actions.ignore.update_moderated_user_button"),
          id: "js-submit-unreport-moderated_users",
          class: "button button__sm button__secondary small button--simple float-left"
        ) %>

    <button id="js-cancel-unreport-moderated_users" class="button button__sm button__secondary js-cancel-bulk-action" type="button">
      <%= t("decidim.admin.moderated_users.index.cancel") %>
    </button>
  <% end %>
</div>